// @tko/utils.functionrewrite 🥊 4.0.0-beta1.3 CommonJS
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var utils_exports = {};
__export(utils_exports, {
  functionRewrite: () => functionRewrite
});
module.exports = __toCommonJS(utils_exports);

// src/functionRewrite.ts
var FUNCTION_REX = /\bfunction\s*\(([^)]*)\)\s*\{\s*(?:(return\s)?([^}]+?)[;\s]*)?\}/g;
function functionRewrite(bindingString) {
  return bindingString.replace(FUNCTION_REX, (match, args, returnKeyword, rv) => {
    if (rv && !returnKeyword) {
      rv += " && undefined";
    }
    const out = `(${args.trim()}) => ${rv}`;
    if (!functionRewrite.silent) {
      console.log(`Knockout: Replace "${match}" with "${out}"`);
    }
    return out;
  });
}
